=== debian/rules ===
#!/usr/bin/make -f

DEBIAN_NAME		:= $(shell dpkg-parsechangelog | sed -n 's/^Source: *\(.*\)$$/\1/ p')
DEBIAN_VERSION		:= $(shell dpkg-parsechangelog | sed -n 's/^Version: *\(.*\)$$/\1/ p')
DEBIAN_UPSTREAM_VERSION	:= $(shell echo $(DEBIAN_VERSION) | sed 's/^\(.*\)-[^-]*$$/\1/')
DEBIAN_REVISION		:= $(shell echo $(DEBIAN_VERSION) | sed 's/^.*r\([^-]*\)-.*/\1/')
DEBIAN_DIST		:= $(shell lsb_release -ds | tr -d '()' |sed -e 's/\#/ /g')
DEBIAN_DIST_NAME	:= $(shell lsb_release -si |sed -e 's/\#/ /g')
DEBIAN_DIST_VERSION	:= $(shell lsb_release -sr |sed -e 's/\#/ /g')

DEBIAN_CODECS_NAME      := $(subst browser,codecs-ffmpeg,$(DEBIAN_NAME))
DEBIAN_DRIVER_NAME      := $(subst browser,chromedriver,$(DEBIAN_NAME))

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# DEB_TAR_SRCDIR has to be 'src' as this is what gyp expects :(
DEB_TAR_SRCDIR := src
SRC_DIR        := $(CURDIR)/$(DEB_TAR_SRCDIR)
LIB_DIR        := usr/lib/$(DEBIAN_NAME)
DEB_BUILDDIR   := $(SRC_DIR)
CDBS_NO_DOC_SYMLINKING := 1 # See LP #194574
KEEPALIVE      := $(CURDIR)/debian/keep-alive.sh

# Whitelist LP provided new langs only in release builds, PPAs ship them all
WANT_ONLY_WHITELISTED_NEW_LANGS ?= 0

ORIG_TARBALL_COMPRESSION ?= xz# bzip2, gzip, lzma, xz
WRAPPED_TARBALL_COMPRESSION ?= none# bz2, gz, lzma, xz, none
ifneq (,$(findstring Ubuntu,$(DEBIAN_DIST)))
 ifneq (,$(findstring 10.04,$(DEBIAN_DIST)))
BINARY_PACKAGE_COMPRESSION ?= bzip2# bzip2, gzip, lzma, xz, none
 else
BINARY_PACKAGE_COMPRESSION ?= xz# bzip2, gzip, lzma, xz, none
 endif
else
BINARY_PACKAGE_COMPRESSION ?= xz# bzip2, gzip, lzma, xz, none
endif
WANT_DEBUG       := 0
WANT_SYSTEM_LIBS ?= 0
WANT_SHARED_LIBS ?= 0
WANT_SANDBOXING  ?= 1
USE_SYSTEM_V8    ?= 0
VERBOSE          ?= 0
PROCESSORS       ?= $(shell grep -ic ^processor /proc/cpuinfo)
ifeq (0,$(PROCESSORS))
PROCESSORS := 1
endif

# Enable the hardening wrapper (See https://wiki.ubuntu.com/Security/HardeningWrapper)
# Don't do it on {hardy,jaunty}+amd64 as it doesn't build for nacl on amd64
# Don't do it on maverick/armel either for now, it fails to link
# Don't do it on lucid/armel either, it crashes: LP #716703
ifeq (armel,$(DEB_BUILD_ARCH))
ifeq (,$(filter 10.04 10.10 11.04,$(DEBIAN_DIST_VERSION)))
export DEB_BUILD_HARDENING=1
else
$(warning ## Not enabling DEB_BUILD_HARDENING on Ubuntu 10.04+ armel. See LP #641126 and LP #716703)
endif
else
ifeq (,$(filter 8.04 9.04,$(DEBIAN_DIST_VERSION)))
export DEB_BUILD_HARDENING=1
else
ifneq (amd64,$(DEB_BUILD_ARCH))
export DEB_BUILD_HARDENING=1
else
$(warning ## Not enabling DEB_BUILD_HARDENING on Ubuntu 8.04/9.04 amd64)
endif
endif
endif
$(warning ## DEB_BUILD_HARDENING=$(DEB_BUILD_HARDENING))

# Disable SSE2
GYP_DEFINES = disable_sse2=1

# Build the launchpad translations (already landed upstream)
GYP_DEFINES += use_third_party_translations=1
# Also merges the newer translations from launchpad
WANT_LP_TRANSLATIONS_IN_BUILD ?= 0

## Policy: 2012-10-30, cm,kv,cc, disabling merging of LP translations. "0"
MERGE_LP_TRANSLATIONS_IN_TARBALL = 0
## Rationale: Instead of merging other stuff before "orig" (!) tarball
## creation, let's export translation templates to Launchpad, and send them
## upstream to be included in the real orig source.  It's slower for circuit,
## but all users win, and is less buggy for us.
##

# Only keep -Werror when building for the Debian or Ubuntu development branches
ifeq (,$(filter unstable development,$(DEBIAN_DIST)))
GYP_DEFINES += werror=$(NULL)
endif

# Disable NaCl until we figure out what to do with the private toolchain
GYP_DEFINES += disable_nacl=1

# do not use third_party/gold as the linker.
GYP_DEFINES += linux_use_gold_binary=0 linux_use_gold_flags=0

ifneq (,$(findstring armhf,$(DEB_BUILD_ARCH)))
GYP_DEFINES += \
	v8_use_arm_eabi_hardfloat=true \
	arm_float_abi=hard \
	$(NULL)
endif

ifneq (,$(findstring arm,$(DEB_BUILD_ARCH)))
GYP_DEFINES += \
	arm_thumb=1 \
	arm_neon=0 \
	arm_fpu=vfpv3-d16 \
	target_arch=arm \
	disable_nacl=1 \
	linux_use_tcmalloc=0 \
	use_libjpeg_turbo=0 \
	use_cups=0 \
	$(NULL)
ifneq (,$(filter 10.10 11.04 11.10 12.04 12.10 unstable development,$(DEBIAN_DIST)))
# on $(DEB_BUILD_ARCH) and $(DEBIAN_DIST), enforce an armv7 with thumb build (or not)
GYP_DEFINES += \
	armv7=1 \
	$(NULL)
endif
else
ifeq (amd64,$(DEB_BUILD_ARCH))
GYP_DEFINES += target_arch=x64
else
ifeq (i386,$(DEB_BUILD_ARCH))
GYP_DEFINES += target_arch=ia32
else
$(warning unsupported target arch $(DEB_BUILD_ARCH) - continuing anyway)
endif
endif
endif

# Don't let dh_installinit install *.default in /etc/default
DEB_DH_INSTALLINIT_ARGS += --noscripts --onlyscripts

# Don't let scour touch the svg files
DEB_DH_SCOUR_ARGS += -Xsvg

DEB_DH_BUILDDEB_ARGS += -- -Z $(BINARY_PACKAGE_COMPRESSION)

ifeq (1,$(WANT_DEBUG))
BUILD_TYPE := Debug
else
BUILD_TYPE := Release
# Add symbols
BUILD_ARGS += SYMBOLS=1
endif
BUILD_ARGS += BUILDTYPE=$(BUILD_TYPE)

# Verbose?
ifeq (1,$(VERBOSE))
BUILD_ARGS += V=1
endif

# Shared libraries
ifeq (1,$(WANT_SHARED_LIBS))
GYP_DEFINES += library=shared_library
endif

# Use upstream build flags (defined in build/common.gypi)
BUILD_ARGS += CFLAGS="" CXXFLAGS="" CPPFLAGS="" LDFLAGS=""

CC_VERSION   := $(shell gcc -dumpversion | cut -d. -f-2)

# Set this to use gcc 4.6 instead of 4.7
AVOID_GCC_47 ?= 0
ifeq (4.7,$(CC_VERSION))
GYP_DEFINES += werror=$(NULL)
ifeq (1,$(AVOID_GCC_47))
CC  := gcc-4.6
CXX := g++-4.6
BUILD_ARGS += CC=$(CC) CXX=$(CXX) CC.host=$(CC) CXX.host=$(CXX) LINK.host=$(CXX)
endif
endif

# Set this to use gcc 4.5 instead of 4.6
AVOID_GCC_46 ?= 0
  
ifeq (4.6,$(CC_VERSION))
GYP_DEFINES += werror=$(NULL)
ifeq (1,$(AVOID_GCC_46))
CC  := gcc-4.5
CXX := g++-4.5
BUILD_ARGS += CC=$(CC) CXX=$(CXX) CC.host=$(CC) CXX.host=$(CXX) LINK.host=$(CXX)
endif
endif
 
# See http://code.google.com/p/chromium/issues/detail?id=49533
ifeq (4.5,$(CC_VERSION))
GYP_DEFINES += werror=$(NULL)
endif

ifeq (bzip2,$(ORIG_TARBALL_COMPRESSION))
 ORIG_TAR_EXT   := bz2
 ORIG_TAR_FLAGS := --bzip2
else ifeq (gzip,$(ORIG_TARBALL_COMPRESSION))
 ORIG_TAR_EXT   := gz
 ORIG_TAR_FLAGS := --gzip
 DEB_TARBALL = $(wildcard *.tar.bz2 *.tar.$(ORIG_TAR_EXT))
else ifeq (lzma,$(ORIG_TARBALL_COMPRESSION))
 ORIG_TAR_EXT   := lzma
 ORIG_TAR_FLAGS := --lzma
 DEB_TARBALL = $(wildcard *.tar.bz2 *.tar.$(ORIG_TAR_EXT))
else ifeq (xz,$(ORIG_TARBALL_COMPRESSION))
 ORIG_TAR_EXT   := xz
 ORIG_TAR_FLAGS := --xz
 DEB_TARBALL = $(wildcard *.tar.bz2 *.tar.$(ORIG_TAR_EXT))
else
 $(error Invalid ORIG_TARBALL_COMPRESSION $(ORIG_TARBALL_COMPRESSION), expected bz2, gz, lzma, or xz)
endif

ifeq (gzip,$(WRAPPED_TARBALL_COMPRESSION))
 WRAPPED_TAR_EXT   := gz
 WRAPPED_TAR_FLAGS := --gzip
else ifeq (bzip2,$(WRAPPED_TARBALL_COMPRESSION))
 WRAPPED_TAR_EXT   := bz2
 WRAPPED_TAR_FLAGS := --bzip2
else ifeq (xz,$(WRAPPED_TARBALL_COMPRESSION))
 WRAPPED_TAR_EXT   := xz
 WRAPPED_TAR_FLAGS := --xz
else ifeq (lzma,$(WRAPPED_TARBALL_COMPRESSION))
 WRAPPED_TAR_EXT   := lzma
 WRAPPED_TAR_FLAGS := --lzma
else ifeq (none,$(WRAPPED_TARBALL_COMPRESSION))
else
 $(error Invalid WRAPPED_TARBALL_COMPRESSION $(WRAPPED_TARBALL_COMPRESSION), expected bz2, gz, lzma, xz, or none)
endif

post-patches::
	perl $(CURDIR)/debian/enable-dist-patches.pl $(DEBIAN_DIST_VERSION) $(CURDIR)/debian/patches/series

include $(CURDIR)/debian/cdbs/tarball.mk
-include /usr/share/cdbs/1/rules/patchsys-quilt.mk
-include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/class/makefile.mk

ifneq (1,$(PROCESSORS))
BUILD_ARGS += -j$(PROCESSORS)
endif

INSTALL_EXCLUDE_DIRS = \
	obj \
	obj.target \
	obj.host \
	.deps \
	calendar_app \
	docs_app \
	gmail_app \
	pyproto \
	pseudo_locales \
	DumpRenderTree_resources \
	$(NULL)

INSTALL_EXCLUDE_FILES = \
	chrome-wrapper \
	product_logo_48.png \
	libnpapi_layout_test_plugin.so \
	libnpapi_test_plugin.so \
	mksnapshot \
	ncdecode_table \
	ncdecode_tablegen \
	ssl_false_start_blacklist_process \
	protoc \
	gfx_unittests \
	linker.lock \
	genmacro \
	genmodule \
	genperf \
